kcapi_kpp_keygen_aio
Prev | Asynchronous Key Protocol Primitives API - One Shot | Next

## Name

kcapi_kpp_keygen_aio — generate a public key (asynchronous one shot)

## Synopsis

`ssize_t kcapi_kpp_keygen_aio (` | struct kcapi_handle * handle,
| struct iovec * outiov,
| size_t iovlen,
| int access`)`;

## Arguments

`handle`

  [in] cipher handle

`outiov`

  [out] head of scatter-gather list of the destination buffers filled with the generated public key

`iovlen`

  [in] number of scatter-gather list entries

`access`

  [in] kernel access type (KCAPI_ACCESS_HEURISTIC - use internal heuristic for fastest kernel access; KCAPI_ACCESS_VMSPLICE - use vmsplice access; KCAPI_ACCESS_SENDMSG - sendmsg access)

## Description

The individual scatter-gather list entries are processed with separate invocations of the the given cipher.

The memory should be aligned at the page boundary using posix_memalign(sysconf(_SC_PAGESIZE)), If it is not aligned at the page boundary, the vmsplice call may not send all data to the kernel.

`return` number of bytes verify upon success; a negative errno-style error code if an error occurred

Prev | Up | Next
Asynchronous Key Protocol Primitives API - One Shot | Home | kcapi_kpp_ssgen_aio